﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using CppCliWrappers;

namespace AppTestVSRC003Wrapper
{
    class Program
    {
        static IntPtr fpathIntPtr;
        static object g_fpathLock = new Object();
        
        static void Main(string[] args)
        {
            string fpath = "init.txt";
            Vsrc003Wrapper vsrc003Wrapper = new Vsrc003Wrapper();
            fpathIntPtr = Marshal.StringToHGlobalAuto(fpath);
          
            vsrc003Wrapper.Init(fpathIntPtr);
            vsrc003Wrapper.LoadMotion(fpathIntPtr);
            vsrc003Wrapper.ServoPowerOn();
            vsrc003Wrapper.PlayMotion(3);
            vsrc003Wrapper.WaitForCompleteMotion();
            vsrc003Wrapper.ServoPowerOff();

            //test analog input
            //Set "ShootAnalogCTRL Slider" to -20!!!!! in your motion file!!!

            fpath = "analogTest_SuperNano.txt";
            fpathIntPtr = Marshal.StringToHGlobalAuto(fpath);
            bool exit = false;
            vsrc003Wrapper.LoadMotion(fpathIntPtr);
            vsrc003Wrapper.ServoPowerOn();
            vsrc003Wrapper.PlayMotion(-1);

            short value = 130;  //servo center position

            while(!exit){
                ConsoleKeyInfo keyInfo = Console.ReadKey(true);
                if (keyInfo.Key == ConsoleKey.Escape)
                {
                    exit = true;
                }
                else {

                   
                    if (keyInfo.Key == ConsoleKey.UpArrow) {
                        value ++;
                    }else if(keyInfo.Key == ConsoleKey.DownArrow){
                        value--;
                    }              

                    vsrc003Wrapper.SetValue(246, value); 
                                 
                }               

            }

            vsrc003Wrapper.CancelMotion();
            vsrc003Wrapper.ServoPowerOff();

            Marshal.FreeHGlobal(fpathIntPtr);

        }
    }
}
