//
// C++/CLI codespace
// Bridge from Managed .NET CLR to Unmanaged C++ and C code.
//
#pragma once


#include "VSRC003_SDK.h"

using namespace System;
using namespace System::Drawing;
using namespace System::Runtime::InteropServices;
using namespace System::Diagnostics;
using namespace System::Collections::Generic;

namespace CppCliWrappers
{
	public ref class Vsrc003Wrapper{
	
	
		private:
			bool m_vsrc003Initialized;

		public:
			Vsrc003Wrapper(){
				m_vsrc003Initialized = false;
		
			}

			~Vsrc003Wrapper(){
		
			}

			bool Init(System::IntPtr fpathIntPtr){				

				wchar_t * fpath = reinterpret_cast<wchar_t*>(fpathIntPtr.ToPointer());
				
				//load init motion and play the motion
				
				if(VSRC003_LoadMotion(fpath)){ System::Console::WriteLine("Failed to load the init motion."); return false;}
				if(VSRC003_PlayMotion(0)){ System::Console::WriteLine("Failed to play the init motion."); return false;}
				else System::Console::WriteLine("Starting init motion.");

				//release memory for fpath
				delete []fpath;

				//wait for finishing startup motion
				do{
					Sleep(16);
				}while(VSRC003_GetStatus()==ERR_PLAYINGMOTION);
				System::Console::WriteLine("Finished playing the init motion");
							
				return true;		
			}

			bool LoadMotion(System::IntPtr fpathIntPtr){

				wchar_t * fpath = reinterpret_cast<wchar_t*>(fpathIntPtr.ToPointer());

				//load motion file
				if(VSRC003_LoadMotion(fpath)){ System::Console::WriteLine("Faild to load motion file."); return false;}
				else System::Console::WriteLine("Finish loading motion");

				return true;
			}

			bool ServoPowerOn(){
				if(VSRC003_ServoPower(1)){ System::Console::WriteLine("Failed to apply power to the servo."); return false;}
				else System::Console::WriteLine("Power applied to the servo.");

				return true;

			}

			bool ServoPowerOff(){
				if(VSRC003_ServoPower(0)){ System::Console::WriteLine("Failed to turn off servo motors\n\n"); return false;}
				else System::Console::WriteLine("Turned off servo motors\n\n");
				return true;
			
			}

			bool PlayMotion(int loopnumber){
				if(VSRC003_PlayMotion(loopnumber)){ System::Console::WriteLine("Failed to play motion."); return false;}
				else System::Console::WriteLine("Start plaing motion.");

				return true;
			}

			bool CancelMotion(){
				if(VSRC003_CancelMotion()){ System::Console::WriteLine("Failed to cancel the motion"); return false;}
				else System::Console::WriteLine("Canceled motion.");

				return true;	
			}

			bool WaitForCompleteMotion(){
				do{
					Sleep(16);
				}while(VSRC003_GetStatus()==ERR_PLAYINGMOTION);
				System::Console::WriteLine("VSRC003Wrapper.WaitforCompleteMotion(): Finished playing the motion");
				Sleep(2000);

				return true;
			}

			int GetStatus(){
				return VSRC003_GetStatus();
			}

			bool SetValue(int valuenumber, short value){
				if(VSRC003_SetValue(valuenumber, value)){
					return false;
				}
				else return true;
			}
	};
}

